/**
  *
  * Klasse fr einen Eulergraph
  *
  * @version 1.0 vom 07.08.2008
  * @author Daniel Garmann
  */

public class Graph {

  private final int MAXKNOTEN = 10;
  private final int MAXKANTEN = 100;
  
  private char[] knoten = new char[MAXKNOTEN];
  private Kante[] kanten = new Kante[MAXKANTEN];
  private int knotenAnzahl;
  private int kantenAnzahl;
  
  public Graph()
  {
    knotenAnzahl = 0;
    kantenAnzahl = 0;
    
  }
  
  public void neueKante(char start, char ziel)
  {
    Kante kante = new Kante(start, ziel);
    kanten[kantenAnzahl] = kante;
    kantenAnzahl++;
  }

  public void neuerKnoten(char name)
  {
    knoten[knotenAnzahl] = name;
    knotenAnzahl++;
  }

  public Weg eulerkreis()
  {
    Weg result = new Weg();
    boolean[] kanteBesucht = new boolean[MAXKANTEN];
    char aktKnoten = knoten[0];
    boolean alleKantenBesucht = false;
    int kantenNr = 0;
    
    while (alleKantenBesucht == false) {
            // Suche Kante, welche vom aktuellen Knoten noch abgeht und nicht besucht wurde
       kantenNr= -1;
       for (int i = 0; i < kantenAnzahl; i++) {
            if ((kanteBesucht[i] == false) &&
               ((kanten[i].gibStart() == aktKnoten) || (kanten[i].gibZiel() == aktKnoten)))
              kantenNr = i;
       }

       if (kantenNr >= 0) {
              // Der Weg lt sich vom AktKnoten aus weiterfhren
              char start = aktKnoten;
              if (aktKnoten != kanten[kantenNr].gibZiel())
                aktKnoten = kanten[kantenNr].gibZiel();
              else
                aktKnoten = kanten[kantenNr].gibStart();
              char ziel = aktKnoten;
              result.neueKante(start,ziel);
              kanteBesucht[kantenNr] = true;
       } else {
              // Der Aktuelle Weg ist ein unvollstndiger Rundweg
              // Starte den Rundweg von einem anderen Knoten ausgehend
              
              result.rotiere();
              aktKnoten = result.gibLetzteKante().gibZiel();
       }
       // Testen, ob alle Kanten besucht sind
       alleKantenBesucht = true;
       for (int i = 0; i< kantenAnzahl; i++){
         if (kanteBesucht[i] == false)
          alleKantenBesucht = false;
       }
    }
    return result;
  }

}
