import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 08.08.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private Graph graph;
  
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JTextField jTextField1 = new JTextField();
  private JTextField jTextField2 = new JTextField();
  private JTextField jTextField_Ausgabe = new JTextField();
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 493;
    int frameHeight = 300;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(16, 8, 44, 16);
    jLabel1.setText("Knoten:");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    jLabel2.setBounds(152, 8, 44, 16);
    jLabel2.setText("Kanten:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jButton1.setBounds(40, 72, 187, 25);
    jButton1.setText("Graph bernehmen");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jButton2.setBounds(40, 104, 185, 25);
    jButton2.setText("Eulerkreis");
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton2_ActionPerformed(evt);
      }
    });
    cp.add(jButton2);
    jTextField1.setBounds(16, 32, 105, 24);
    jTextField1.setText("A,B,C,D,E,F");
    cp.add(jTextField1);
    jTextField2.setBounds(152, 32, 257, 24);
    jTextField2.setText("AB,AC,AD,AE,BC,BC,BE,DE,DF,EF");
    cp.add(jTextField2);
    jTextField_Ausgabe.setBounds(40, 144, 185, 24);
    jTextField_Ausgabe.setText("-----");
    cp.add(jTextField_Ausgabe);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jButton1_ActionPerformed(ActionEvent evt) {
    // Graph bernehmen
    graph = new Graph();
    
    String s = jTextField1.getText();
    String knoten[] = s.split(",");
    for (int i=0; i< knoten.length; i++){
      char b = knoten[i].charAt(0);
      graph.neuerKnoten(b);
    }

    s = jTextField2.getText();
    String kanten[] = s.split(",");
    for (int i=0; i< kanten.length; i++){
      char b1 = kanten[i].charAt(0);
      char b2 = kanten[i].charAt(1);
      graph.neueKante(b1, b2);
    }
  }

  public void jButton2_ActionPerformed(ActionEvent evt) {
    // Eulerkreissuche
    Weg weg = graph.eulerkreis();
    String s = weg.ausgabe();
    jTextField_Ausgabe.setText(s);
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
